diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/wifi/test/tx-duration-test.cc ns-3.34/src/wifi/test/tx-duration-test.cc
--- ns-3.33/src/wifi/test/tx-duration-test.cc	2021-01-09 10:19:23.000000000 -0800
+++ ns-3.34/src/wifi/test/tx-duration-test.cc	2021-07-14 10:31:07.000000000 -0700
@@ -552,19 +540,19 @@
   retval = retval
     && CheckHeMuTxDuration (std::list<uint32_t> {1536,
                                                  1536},
-                            std::list<HeMuUserInfo> { {{true, HeRu::RU_242_TONE, 1}, WifiPhy::GetHeMcs0 (), 1},
-                                                      {{true, HeRu::RU_242_TONE, 2}, WifiPhy::GetHeMcs0 (), 1} },
-                            40, 800, NanoSeconds (1489600)) //equivalent to HE_SU for 20 MHz with extra HE-SIG-B (i.e. 4 us)
+                            std::list<HeMuUserInfo> { {{HeRu::RU_242_TONE, 1, true}, HePhy::GetHeMcs0 (), 1},
+                                                      {{HeRu::RU_242_TONE, 2, true}, HePhy::GetHeMcs0 (), 1} },
+                            40, 800, NanoSeconds (1493600)) //equivalent to HE_SU for 20 MHz with 2 extra HE-SIG-B (i.e. 8 us)
   && CheckHeMuTxDuration (std::list<uint32_t> {1536,
                                                1536},
-                          std::list<HeMuUserInfo> { {{true, HeRu::RU_242_TONE, 1}, WifiPhy::GetHeMcs1 (), 1},
-                                                    {{true, HeRu::RU_242_TONE, 2}, WifiPhy::GetHeMcs0 (), 1} },
-                          40, 800, NanoSeconds (1489600)) //shouldn't change if first PSDU is shorter
+                          std::list<HeMuUserInfo> { {{HeRu::RU_242_TONE, 1, true}, HePhy::GetHeMcs1 (), 1},
+                                                    {{HeRu::RU_242_TONE, 2, true}, HePhy::GetHeMcs0 (), 1} },
+                          40, 800, NanoSeconds (1493600)) //shouldn't change if first PSDU is shorter
   && CheckHeMuTxDuration (std::list<uint32_t> {1536,
                                                76},
-                          std::list<HeMuUserInfo> { {{true, HeRu::RU_242_TONE, 1}, WifiPhy::GetHeMcs0 (), 1},
-                                                    {{true, HeRu::RU_242_TONE, 2}, WifiPhy::GetHeMcs0 (), 1} },
-                          40, 800, NanoSeconds (1489600));
+                          std::list<HeMuUserInfo> { {{HeRu::RU_242_TONE, 1, true}, HePhy::GetHeMcs0 (), 1},
+                                                    {{HeRu::RU_242_TONE, 2, true}, HePhy::GetHeMcs0 (), 1} },
+                          40, 800, NanoSeconds (1493600));
 
   NS_TEST_EXPECT_MSG_EQ (retval, true, "an 802.11ax MU duration failed");
 
@@ -575,6 +563,414 @@
  * \ingroup wifi-test
  * \ingroup tests
  *
+ * \brief HE-SIG-B duration test
+ */
+class HeSigBDurationTest : public TestCase
+{
+public:
+  HeSigBDurationTest ();
+  virtual ~HeSigBDurationTest ();
+  void DoRun (void) override;
+
+private:
+  /**
+   * Build a TXVECTOR for HE MU with the given bandwith and user informations.
+   *
+   * \param bw the channel width of the PPDU in MHz
+   * \param userInfos the list of HE MU specific user transmission parameters
+   *
+   * \return the configured HE MU TXVECTOR
+   */
+  static WifiTxVector BuildTxVector (uint16_t bw, std::list <HeMuUserInfo> userInfos);
+};
+
+HeSigBDurationTest::HeSigBDurationTest ()
+  : TestCase ("Check HE-SIG-B duration computation")
+{
+}
+
+HeSigBDurationTest::~HeSigBDurationTest ()
+{
+}
+
+WifiTxVector
+HeSigBDurationTest::BuildTxVector (uint16_t bw, std::list <HeMuUserInfo> userInfos)
+{
+  WifiTxVector txVector;
+  txVector.SetPreambleType (WIFI_PREAMBLE_HE_MU);
+  txVector.SetChannelWidth (bw);
+  txVector.SetGuardInterval (3200);
+  txVector.SetStbc (0);
+  txVector.SetNess (0);
+  std::list<uint16_t> staIds;
+  uint16_t staId = 1;
+  for (const auto & userInfo : userInfos)
+    {
+      txVector.SetHeMuUserInfo (staId, userInfo);
+      staIds.push_back (staId++);
+    }
+  return txVector;
+}
+
+void
+HeSigBDurationTest::DoRun (void)
+{
+  const auto & hePhy = WifiPhy::GetStaticPhyEntity(WIFI_MOD_CLASS_HE);
+
+  //20 MHz band
+  std::list<HeMuUserInfo> userInfos;
+  userInfos.push_back ({{HeRu::RU_106_TONE, 1, true}, HePhy::GetHeMcs11 (), 1});
+  userInfos.push_back ({{HeRu::RU_106_TONE, 2, true}, HePhy::GetHeMcs10 (), 4});
+  WifiTxVector txVector = BuildTxVector (20, userInfos);
+  NS_TEST_EXPECT_MSG_EQ (hePhy->GetSigMode (WIFI_PPDU_FIELD_SIG_B, txVector), VhtPhy::GetVhtMcs5 (), "HE-SIG-B should be sent at MCS 5");
+  std::pair<std::size_t, std::size_t> numUsersPerCc = txVector.GetNumRusPerHeSigBContentChannel ();
+  NS_TEST_EXPECT_MSG_EQ (numUsersPerCc.first, 2, "Both users should be on HE-SIG-B content channel 1");
+  NS_TEST_EXPECT_MSG_EQ (numUsersPerCc.second, 0, "Both users should be on HE-SIG-B content channel 2");
+  NS_TEST_EXPECT_MSG_EQ (hePhy->GetDuration (WIFI_PPDU_FIELD_SIG_B, txVector), MicroSeconds (4), "HE-SIG-B should only last one OFDM symbol");
+
+  //40 MHz band, even number of users per HE-SIG-B content channel
+  userInfos.push_back ({{HeRu::RU_52_TONE, 5, true}, HePhy::GetHeMcs4 (), 1});
+  userInfos.push_back ({{HeRu::RU_52_TONE, 6, true}, HePhy::GetHeMcs6 (), 2});
+  userInfos.push_back ({{HeRu::RU_52_TONE, 7, true}, HePhy::GetHeMcs5 (), 3});
+  userInfos.push_back ({{HeRu::RU_52_TONE, 8, true}, HePhy::GetHeMcs6 (), 2});
+  txVector = BuildTxVector (40, userInfos);
+  NS_TEST_EXPECT_MSG_EQ (hePhy->GetSigMode (WIFI_PPDU_FIELD_SIG_B, txVector), VhtPhy::GetVhtMcs4 (), "HE-SIG-B should be sent at MCS 4");
+  numUsersPerCc = txVector.GetNumRusPerHeSigBContentChannel ();
+  NS_TEST_EXPECT_MSG_EQ (numUsersPerCc.first, 2, "Two users should be on HE-SIG-B content channel 1");
+  NS_TEST_EXPECT_MSG_EQ (numUsersPerCc.second, 4, "Four users should be on HE-SIG-B content channel 2");
+  NS_TEST_EXPECT_MSG_EQ (hePhy->GetDuration (WIFI_PPDU_FIELD_SIG_B, txVector), MicroSeconds (4), "HE-SIG-B should only last one OFDM symbol");
+
+  //40 MHz band, odd number of users per HE-SIG-B content channel
+  userInfos.push_back ({{HeRu::RU_26_TONE, 13, true}, HePhy::GetHeMcs3 (), 1});
+  txVector = BuildTxVector (40, userInfos);
+  NS_TEST_EXPECT_MSG_EQ (hePhy->GetSigMode (WIFI_PPDU_FIELD_SIG_B, txVector), VhtPhy::GetVhtMcs3 (), "HE-SIG-B should be sent at MCS 3");
+  numUsersPerCc = txVector.GetNumRusPerHeSigBContentChannel ();
+  NS_TEST_EXPECT_MSG_EQ (numUsersPerCc.first, 2, "Two users should be on HE-SIG-B content channel 1");
+  NS_TEST_EXPECT_MSG_EQ (numUsersPerCc.second, 5, "Five users should be on HE-SIG-B content channel 2");
+  NS_TEST_EXPECT_MSG_EQ (hePhy->GetDuration (WIFI_PPDU_FIELD_SIG_B, txVector), MicroSeconds (8), "HE-SIG-B should last two OFDM symbols");
+
+  //80 MHz band
+  userInfos.push_back ({{HeRu::RU_242_TONE, 3, true}, HePhy::GetHeMcs1 (), 1});
+  userInfos.push_back ({{HeRu::RU_242_TONE, 4, true}, HePhy::GetHeMcs4 (), 1});
+  txVector = BuildTxVector (80, userInfos);
+  NS_TEST_EXPECT_MSG_EQ (hePhy->GetSigMode (WIFI_PPDU_FIELD_SIG_B, txVector), VhtPhy::GetVhtMcs1 (), "HE-SIG-B should be sent at MCS 1");
+  numUsersPerCc = txVector.GetNumRusPerHeSigBContentChannel ();
+  NS_TEST_EXPECT_MSG_EQ (numUsersPerCc.first, 3, "Three users should be on HE-SIG-B content channel 1");
+  NS_TEST_EXPECT_MSG_EQ (numUsersPerCc.second, 6, "Six users should be on HE-SIG-B content channel 2");
+  NS_TEST_EXPECT_MSG_EQ (hePhy->GetDuration (WIFI_PPDU_FIELD_SIG_B, txVector), MicroSeconds (16), "HE-SIG-B should last four OFDM symbols");
+
+  //160 MHz band
+  userInfos.push_back ({{HeRu::RU_996_TONE, 1, false}, HePhy::GetHeMcs1 (), 1});
+  txVector = BuildTxVector (160, userInfos);
+  NS_TEST_EXPECT_MSG_EQ (hePhy->GetSigMode (WIFI_PPDU_FIELD_SIG_B, txVector), VhtPhy::GetVhtMcs1 (), "HE-SIG-B should be sent at MCS 1");
+  numUsersPerCc = txVector.GetNumRusPerHeSigBContentChannel ();
+  NS_TEST_EXPECT_MSG_EQ (numUsersPerCc.first, 4, "Four users should be on HE-SIG-B content channel 1");
+  NS_TEST_EXPECT_MSG_EQ (numUsersPerCc.second, 7, "Seven users should be on HE-SIG-B content channel 2");
+  NS_TEST_EXPECT_MSG_EQ (hePhy->GetDuration (WIFI_PPDU_FIELD_SIG_B, txVector), MicroSeconds (20), "HE-SIG-B should last five OFDM symbols");
+}
+
+/**
+ * \ingroup wifi-test
+ * \ingroup tests
+ *
+ * \brief PHY header sections consistency test
+ */
+class PhyHeaderSectionsTest : public TestCase
+{
+public:
+  PhyHeaderSectionsTest ();
+  virtual ~PhyHeaderSectionsTest ();
+  void DoRun (void) override;
+
+
+private:
+  /**
+   * Check if map of PHY header sections returned by a given PHY entity
+   * corresponds to a known value
+   *
+   * @param obtained the map of PHY header sections to check
+   * @param expected the expected map of PHY header sections
+   */
+  void CheckPhyHeaderSections (PhyEntity::PhyHeaderSections obtained,
+                               PhyEntity::PhyHeaderSections expected);
+};
+
+PhyHeaderSectionsTest::PhyHeaderSectionsTest ()
+  : TestCase ("PHY header sections consistency")
+{
+}
+
+PhyHeaderSectionsTest::~PhyHeaderSectionsTest ()
+{
+}
+
+void
+PhyHeaderSectionsTest::CheckPhyHeaderSections (PhyEntity::PhyHeaderSections obtained,
+                                               PhyEntity::PhyHeaderSections expected)
+{
+  NS_TEST_EXPECT_MSG_EQ (obtained.size (), expected.size (), "The expected map size (" << expected.size () << ") was not obtained (" << obtained.size () << ")");
+
+  auto itObtained = obtained.begin ();
+  auto itExpected = expected.begin ();
+  for (;itObtained != obtained.end () || itExpected != expected.end ();)
+    {
+      WifiPpduField field = itObtained->first;
+      auto window = itObtained->second.first;
+      auto mode = itObtained->second.second;
+
+      WifiPpduField fieldRef = itExpected->first;
+      auto windowRef = itExpected->second.first;
+      auto modeRef = itExpected->second.second;
+
+      NS_TEST_EXPECT_MSG_EQ (field, fieldRef, "The expected PPDU field (" << fieldRef << ") was not obtained (" << field << ")");
+      NS_TEST_EXPECT_MSG_EQ (window.first, windowRef.first, "The expected start time (" << windowRef.first << ") was not obtained (" << window.first << ")");
+      NS_TEST_EXPECT_MSG_EQ (window.second, windowRef.second, "The expected stop time (" << windowRef.second << ") was not obtained (" << window.second << ")");
+      NS_TEST_EXPECT_MSG_EQ (mode, modeRef, "The expected mode (" << modeRef << ") was not obtained (" << mode << ")");
+      ++itObtained;
+      ++itExpected;
+    }
+}
+
+void
+PhyHeaderSectionsTest::DoRun (void)
+{
+  Time ppduStart = Seconds (1.0);
+  Ptr<PhyEntity> phyEntity;
+  PhyEntity::PhyHeaderSections sections;
+  WifiTxVector txVector;
+  WifiMode nonHtMode;
+
+
+  // ==================================================================================
+  // 11b (HR/DSSS)
+  phyEntity = Create<DsssPhy> ();
+  txVector.SetMode (DsssPhy::GetDsssRate1Mbps ());
+  txVector.SetChannelWidth (22);
+
+  // -> long PPDU format
+  txVector.SetPreambleType (WIFI_PREAMBLE_LONG);
+  nonHtMode = DsssPhy::GetDsssRate1Mbps ();
+  sections = { { WIFI_PPDU_FIELD_PREAMBLE, { { ppduStart,
+                                               ppduStart + MicroSeconds (144) },
+                                             nonHtMode } },
+               { WIFI_PPDU_FIELD_NON_HT_HEADER, { { ppduStart + MicroSeconds (144),
+                                                    ppduStart + MicroSeconds (192) },
+                                                  nonHtMode } } };
+  CheckPhyHeaderSections (phyEntity->GetPhyHeaderSections (txVector, ppduStart), sections);
+
+  // -> long PPDU format if data rate is 1 Mbps (even if preamble is tagged short)
+  txVector.SetPreambleType (WIFI_PREAMBLE_SHORT);
+  CheckPhyHeaderSections (phyEntity->GetPhyHeaderSections (txVector, ppduStart), sections);
+
+  // -> short PPDU format
+  txVector.SetMode (DsssPhy::GetDsssRate11Mbps ());
+  nonHtMode = DsssPhy::GetDsssRate2Mbps ();
+  txVector.SetPreambleType (WIFI_PREAMBLE_SHORT);
+  sections = { { WIFI_PPDU_FIELD_PREAMBLE, { { ppduStart,
+                                               ppduStart + MicroSeconds (72) },
+                                             nonHtMode } },
+               { WIFI_PPDU_FIELD_NON_HT_HEADER, { { ppduStart + MicroSeconds (72),
+                                                    ppduStart + MicroSeconds (96) },
+                                                  nonHtMode } } };
+  CheckPhyHeaderSections (phyEntity->GetPhyHeaderSections (txVector, ppduStart), sections);
+
+
+  // ==================================================================================
+  // 11a (OFDM)
+  txVector.SetPreambleType (WIFI_PREAMBLE_LONG);
+
+  // -> one iteration per variant: default, 10 MHz, and 5 MHz
+  std::map<OfdmPhyVariant, std::size_t> variants { //number to use to deduce rate and BW info for each variant
+    { OFDM_PHY_DEFAULT, 1},
+    { OFDM_PHY_10_MHZ,  2},
+    { OFDM_PHY_5_MHZ,   4}
+  };
+  for (auto variant : variants)
+    {
+      phyEntity = Create<OfdmPhy> (variant.first);
+      std::size_t ratio = variant.second;
+      uint16_t bw = 20 / ratio; //MHz
+      txVector.SetChannelWidth (bw);
+      txVector.SetMode (OfdmPhy::GetOfdmRate (12000000 / ratio, bw));
+      nonHtMode = OfdmPhy::GetOfdmRate (6000000 / ratio, bw);
+      sections = { { WIFI_PPDU_FIELD_PREAMBLE, { { ppduStart,
+                                                   ppduStart + MicroSeconds (16 * ratio) },
+                                                 nonHtMode } },
+                   { WIFI_PPDU_FIELD_NON_HT_HEADER, { { ppduStart + MicroSeconds (16 * ratio),
+                                                        ppduStart + MicroSeconds (20 * ratio) },
+                                                      nonHtMode } } };
+      CheckPhyHeaderSections (phyEntity->GetPhyHeaderSections (txVector, ppduStart), sections);
+    }
+
+
+  // ==================================================================================
+  // 11g (ERP-OFDM)
+  phyEntity = Create<ErpOfdmPhy> ();
+  txVector.SetChannelWidth (20);
+  txVector.SetMode (ErpOfdmPhy::GetErpOfdmRate (54000000));
+  nonHtMode = ErpOfdmPhy::GetErpOfdmRate6Mbps ();
+  sections = { { WIFI_PPDU_FIELD_PREAMBLE, { { ppduStart,
+                                               ppduStart + MicroSeconds (16) },
+                                             nonHtMode } },
+               { WIFI_PPDU_FIELD_NON_HT_HEADER, { { ppduStart + MicroSeconds (16),
+                                                    ppduStart + MicroSeconds (20) },
+                                                  nonHtMode } } };
+  CheckPhyHeaderSections (phyEntity->GetPhyHeaderSections (txVector, ppduStart), sections);
+
+
+  // ==================================================================================
+  // 11n (HT)
+  phyEntity = Create<HtPhy> (4);
+  txVector.SetChannelWidth (20);
+  txVector.SetMode (HtPhy::GetHtMcs6 ());
+  nonHtMode = OfdmPhy::GetOfdmRate6Mbps ();
+  WifiMode htSigMode = nonHtMode;
+
+  // -> HT-mixed format for 2 SS and no ESS
+  txVector.SetPreambleType (WIFI_PREAMBLE_HT_MF);
+  txVector.SetNss (2);
+  txVector.SetNess (0);
+  sections = { { WIFI_PPDU_FIELD_PREAMBLE, { { ppduStart,
+                                               ppduStart + MicroSeconds (16) },
+                                             nonHtMode } },
+               { WIFI_PPDU_FIELD_NON_HT_HEADER, { { ppduStart + MicroSeconds (16),
+                                                    ppduStart + MicroSeconds (20) },
+                                                  nonHtMode } },
+               { WIFI_PPDU_FIELD_HT_SIG, { { ppduStart + MicroSeconds (20),
+                                             ppduStart + MicroSeconds (28) },
+                                           htSigMode } },
+               { WIFI_PPDU_FIELD_TRAINING, { { ppduStart + MicroSeconds (28),
+                                               ppduStart + MicroSeconds (40) }, // 1 HT-STF + 2 HT-LTFs
+                                             htSigMode } } };
+  CheckPhyHeaderSections (phyEntity->GetPhyHeaderSections (txVector, ppduStart), sections);
+  txVector.SetChannelWidth (20); //shouldn't have any impact
+  CheckPhyHeaderSections (phyEntity->GetPhyHeaderSections (txVector, ppduStart), sections);
+
+  // -> HT-mixed format for 3 SS and 1 ESS
+  txVector.SetNss (3);
+  txVector.SetNess (1);
+  sections[WIFI_PPDU_FIELD_TRAINING] = { { ppduStart + MicroSeconds (28),
+                                           ppduStart + MicroSeconds (52) }, // 1 HT-STF + 5 HT-LTFs (4 data + 1 extension)
+                                         htSigMode };
+  CheckPhyHeaderSections (phyEntity->GetPhyHeaderSections (txVector, ppduStart), sections);
+
+
+  // ==================================================================================
+  // 11ac (VHT)
+  phyEntity = Create<VhtPhy> ();
+  txVector.SetChannelWidth (20);
+  txVector.SetNess (0);
+  txVector.SetMode (VhtPhy::GetVhtMcs7 ());
+  WifiMode sigAMode = nonHtMode;
+  WifiMode sigBMode = VhtPhy::GetVhtMcs0 ();
+
+  // -> VHT SU format for 5 SS
+  txVector.SetPreambleType (WIFI_PREAMBLE_VHT_SU);
+  txVector.SetNss (5);
+  sections = { { WIFI_PPDU_FIELD_PREAMBLE, { { ppduStart,
+                                               ppduStart + MicroSeconds (16) },
+                                             nonHtMode } },
+               { WIFI_PPDU_FIELD_NON_HT_HEADER, { { ppduStart + MicroSeconds (16),
+                                                    ppduStart + MicroSeconds (20) },
+                                                  nonHtMode } },
+               { WIFI_PPDU_FIELD_SIG_A, { { ppduStart + MicroSeconds (20),
+                                            ppduStart + MicroSeconds (28) },
+                                          sigAMode } },
+               { WIFI_PPDU_FIELD_TRAINING, { { ppduStart + MicroSeconds (28),
+                                               ppduStart + MicroSeconds (56) }, // 1 VHT-STF + 6 VHT-LTFs
+                                             sigAMode } } };
+  CheckPhyHeaderSections (phyEntity->GetPhyHeaderSections (txVector, ppduStart), sections);
+
+  // -> VHT SU format for 7 SS
+  txVector.SetNss (7);
+  sections[WIFI_PPDU_FIELD_TRAINING] = { { ppduStart + MicroSeconds (28),
+                                           ppduStart + MicroSeconds (64) }, // 1 VHT-STF + 8 VHT-LTFs
+                                         sigAMode };
+  CheckPhyHeaderSections (phyEntity->GetPhyHeaderSections (txVector, ppduStart), sections);
+
+  // -> VHT MU format for 3 SS
+  txVector.SetPreambleType (WIFI_PREAMBLE_VHT_MU);
+  txVector.SetNss (3);
+  sections[WIFI_PPDU_FIELD_TRAINING] = { { ppduStart + MicroSeconds (28),
+                                           ppduStart + MicroSeconds (48) }, // 1 VHT-STF + 4 VHT-LTFs
+                                         sigAMode };
+  sections[WIFI_PPDU_FIELD_SIG_B] = { { ppduStart + MicroSeconds (48),
+                                        ppduStart + MicroSeconds (52) },
+                                       sigBMode };
+  CheckPhyHeaderSections (phyEntity->GetPhyHeaderSections (txVector, ppduStart), sections);
+  txVector.SetChannelWidth (80); //shouldn't have any impact
+  CheckPhyHeaderSections (phyEntity->GetPhyHeaderSections (txVector, ppduStart), sections);
+
+
+  // ==================================================================================
+  // 11ax (HE)
+  phyEntity = Create<HePhy> ();
+  txVector.SetChannelWidth (20);
+  txVector.SetNss (2); //HE-LTF duration assumed to be always 8 us for the time being (see note in HePhy::GetTrainingDuration)
+  txVector.SetMode (HePhy::GetHeMcs9 ());
+  std::map<uint16_t, HeMuUserInfo> userInfoMap = { { 1, { {HeRu::RU_106_TONE, 1, true}, HePhy::GetHeMcs4 (), 2 } },
+                                                   { 2, { {HeRu::RU_106_TONE, 1, true}, HePhy::GetHeMcs9 (), 1 } } };
+  sigAMode = HePhy::GetVhtMcs0 ();
+  sigBMode = HePhy::GetVhtMcs4 (); //because of first user info map
+
+  // -> HE SU format
+  txVector.SetPreambleType (WIFI_PREAMBLE_HE_SU);
+  sections = { { WIFI_PPDU_FIELD_PREAMBLE, { { ppduStart,
+                                               ppduStart + MicroSeconds (16) },
+                                             nonHtMode } },
+               { WIFI_PPDU_FIELD_NON_HT_HEADER, { { ppduStart + MicroSeconds (16),
+                                                    ppduStart + MicroSeconds (24) }, // L-SIG + RL-SIG
+                                                  nonHtMode } },
+               { WIFI_PPDU_FIELD_SIG_A, { { ppduStart + MicroSeconds (24),
+                                            ppduStart + MicroSeconds (32) },
+                                          sigAMode } },
+               { WIFI_PPDU_FIELD_TRAINING, { { ppduStart + MicroSeconds (32),
+                                               ppduStart + MicroSeconds (52) }, // 1 HE-STF (@ 4 us) + 2 HE-LTFs (@ 8 us)
+                                             sigAMode } } };
+  CheckPhyHeaderSections (phyEntity->GetPhyHeaderSections (txVector, ppduStart), sections);
+
+  // -> HE ER SU format
+  txVector.SetPreambleType (WIFI_PREAMBLE_HE_ER_SU);
+  sections[WIFI_PPDU_FIELD_SIG_A] = { { ppduStart + MicroSeconds (24),
+                                        ppduStart + MicroSeconds (40) }, // 16 us HE-SIG-A
+                                      sigAMode };
+  sections[WIFI_PPDU_FIELD_TRAINING] = { { ppduStart + MicroSeconds (40),
+                                           ppduStart + MicroSeconds (60) }, // 1 HE-STF (@ 4 us) + 2 HE-LTFs (@ 8 us)
+                                         sigAMode };
+  CheckPhyHeaderSections (phyEntity->GetPhyHeaderSections (txVector, ppduStart), sections);
+
+  // -> HE TB format
+  txVector.SetPreambleType (WIFI_PREAMBLE_HE_TB);
+  txVector.SetHeMuUserInfo (1, userInfoMap.at (1));
+  txVector.SetHeMuUserInfo (2, userInfoMap.at (2));
+  sections[WIFI_PPDU_FIELD_SIG_A] = { { ppduStart + MicroSeconds (24),
+                                        ppduStart + MicroSeconds (32) },
+                                      sigAMode };
+  sections[WIFI_PPDU_FIELD_TRAINING] = { { ppduStart + MicroSeconds (32),
+                                           ppduStart + MicroSeconds (56) }, // 1 HE-STF (@ 8 us) + 2 HE-LTFs (@ 8 us)
+                                         sigAMode };
+  CheckPhyHeaderSections (phyEntity->GetPhyHeaderSections (txVector, ppduStart), sections);
+
+  // -> HE MU format
+  txVector.SetPreambleType (WIFI_PREAMBLE_HE_MU);
+  sections[WIFI_PPDU_FIELD_SIG_A] = { { ppduStart + MicroSeconds (24),
+                                        ppduStart + MicroSeconds (32) },
+                                      sigAMode };
+  sections[WIFI_PPDU_FIELD_SIG_B] = { { ppduStart + MicroSeconds (32),
+                                        ppduStart + MicroSeconds (36) }, // only one symbol
+                                       sigBMode };
+  sections[WIFI_PPDU_FIELD_TRAINING] = { { ppduStart + MicroSeconds (36),
+                                           ppduStart + MicroSeconds (56) }, // 1 HE-STF (@ 4 us) + 2 HE-LTFs (@ 8 us)
+                                         sigBMode };
+  CheckPhyHeaderSections (phyEntity->GetPhyHeaderSections (txVector, ppduStart), sections);
+  txVector.SetChannelWidth (160); //shouldn't have any impact
+  CheckPhyHeaderSections (phyEntity->GetPhyHeaderSections (txVector, ppduStart), sections);
+}
+
+/**
+ * \ingroup wifi-test
+ * \ingroup tests
+ *
  * \brief Tx Duration Test Suite
  */
 class TxDurationTestSuite : public TestSuite
@@ -586,7 +982,9 @@
 TxDurationTestSuite::TxDurationTestSuite ()
   : TestSuite ("wifi-devices-tx-duration", UNIT)
 {
+  AddTestCase (new HeSigBDurationTest, TestCase::QUICK);
   AddTestCase (new TxDurationTest, TestCase::QUICK);
+  AddTestCase (new PhyHeaderSectionsTest, TestCase::QUICK);
 }
 
 static TxDurationTestSuite g_txDurationTestSuite; ///< the test suite
